﻿// #AdvancedSearch[Es].jsx

/*
   
v.10072022  

=== Texto del portapapeles en la línea de búsqueda ===

Busque en el documento texto colocado en el búfer. Algunas palabras o algunos párrafos; no importa.

Cambiar espacios a espacios, cambiar el tipo de comillas, eliminar espacios duplicados, cambiar un guion a un signo menos o una raya es la razón principal de que no sea fácil la búsqueda, en el diseño interior, del texto llevado al búfer dsde un documento de Word o un archivo PDF.

Al preparar el texto para componerlo se eliminaron los espacios repetidos, el guion en la secuencia de caracteres "espacio-guion-espacio" entre palabras se reemplazó con un guion o un signo menos, se cambió el tipo de comillas.
Algunos epacios se han convertido en sus variantes. Esto, por supuesto, es correcto. Pero la comodidad de buscar texto ha desaparecido. Es imposible llevar el texto del documento de Word al portapapeles y encontrarlo inmediatamente en el diseño.

Este script le permite buscar en el diseño el texto almacenado en el búfer, ignorando los siguientes casos:
= espacios repetidos, y el hecho de que puedan convertirse en variaciones;
= guiones/menos/rayas rodeadas de guiones se consideran los mismos caracteres;
= si hay una comilla, entonces puede ser de cualquier tipo;
= la diferencia en el número de saltos de línea repetidos no se considera una discrepancia entre el texto armado y el texto de origen.

Los signos de puntuación (coma, punto, etc.) deben ser los mismos que en el texto enviado para el diseño. Aquí no puede haber excepciones.

Esta solución le permite almacenar en el búfer texto sin formato desde un documento de Word, el bloc de notas o un archivo PDF y buscarlo en el diseño.
Es más, para la búsqueda que hará este "script" solo se tendrá en cuenta, entonces, el contenido del texto, sin el control de las variaciones, comillas, o de lo que se utilice como guion, y se colocará esa línea en el campo "Buscar texto:" en el panel GREP

El texto del búfer se cambia para que las variantes de espacios y los diferentes tipos de comillas no sean un obstáculo para la búsqueda.
- en el texto del búfer, los espacios se reemplazan con \h (el código de búsqueda GREP de espacios y tabulaciones).
- el tipo de comillas también será diferente; se pone un punto en su lugar, como el código de cualquier signo.
- el texto preparado para la búsqueda se coloca en el campo de búsqueda GREP.

La búsqueda se realiza desde el punto de inserción del cursor hasta el final del material, si el cursor está en el texto, o en el área seleccionada del material.
El texto encontrado se muestra en el centro de la pantalla a una escala del 150%.

Guion para versiones CS6+.

Las instrucciones sobre el uso de este programa se encuentran con acentos ligeramente diferentes en el archivo PDF adjunto.

-----------------------------------------------
Mikhail Ivanyushin
https://shop.dotextok.ru /en   |   dotextok@gmail.com
----------------------------------------------

*/

var mes1 = "Texto del portapapeles en la línea de búsqueda";
var mes2 = "No hay documentos abiertos";
var mes3 = "Este guion es para InDesign CS6+";
var mes4 = "El script busca el texto guardado en el portapapeles. Si parte del material está resaltado, busca en el área resaltada. Si el cursor está en el texto, busca en el artículo, desde el punto de inserción del cursor hasta el final.";
var mes5A = "No se encontró el archivo PDF con la descripción de este programa. Se llama '";
var mes5B = "' y debe estar en la misma carpeta donde está el guion.";
var mes6 = "Parece que no hay texto en el portapapeles. O el contenido del portapapeles no es texto.";
var mes7 = "Texto no encontrado.";

//-----------------
var showPDF = true; // если true, то после сообщения, как определять область поиска, будет выведен PDF-файл Advanced Search Info[lng].pdf

app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; // см. http://adobeindesign.ru/2008/10/24/restore-ui/
var programTitul = mes1; // "Текст буфера в строке поиска"
if(app.documents.length == 0) {
    alert(mes2, programTitul); // "Нет открытого документа."
    exit();    
    }
if (parseInt (app.version) < 8) {
	alert (mes3, programTitul); // "Этот скрипт предназначен для использования в InDesign CS6+."
    exit();
    }
var sel = app.selection[0];
if ((sel == null) || (sel.constructor.name != "InsertionPoint" && sel.constructor.name != "Paragraph" && sel.constructor.name != "Text" && sel.constructor.name != "TextColumn" && sel.constructor.name != "TextStyleRange")) { // == null
    alert(mes4,programTitul); // "Скрипт ищет в вёрстке сохранённый в буфере текст. Если часть материала выделена, то поиск в выделенной области. Если курсор в тексте, то поиск в материале, начиная от точки вставки курсора до конца статьи."
    if (showPDF) { // showPDF
        app.pdfExportPreferences.properties.viewPDF = true;   
        var myScriptFile = getScriptPath();
        var myScriptFolder = decodeURI(myScriptFile.path);  
      //  var pdfName = "Advanced Search Info.pdf";
        var pdfName = "Advanced Search Info[Es].pdf";        
        var infoFile = File(decodeURI(myScriptFolder + "/" + pdfName));
        if (!infoFile.exists) { alert(meso5A + pdfName + mes5B,programTitul); } // "Не найден PDF-файл с описанием этой программы. Он называется '"       "' и должен быть в той же папке, где скрипт."
        else { infoFile.execute(); }
        } // showPDF
    exit(); 
    } // == null
var story = sel.parentStory;    
var space;
if (sel.constructor.name == "InsertionPoint") {
    var startIndex = sel.index;
    var endIndex = story.length-1;
    story.characters.itemByRange(startIndex, endIndex).select();
    space = app.selection[0];
    }
else space = sel;
var startPosition = space.characters[0].index;
var usedZoom = app.activeWindow.zoomPercentage;
var theFrame = app.activeWindow.activePage.textFrames.add({strokeWeight:0});
if (theFrame.strokeWeight != 0) theFrame.strokeWeight = 0;
theFrame.geometricBounds = ["-45mm",0,"-40mm","140mm"];
theFrame.texts[0].appliedParagraphStyle = app.activeDocument.paragraphStyles[0];
theFrame.texts[0].clearOverrides();
theFrame.textFramePreferences.ignoreWrap = true;
theFrame.textFramePreferences.verticalJustification = VerticalJustification.TOP_ALIGN; 
theFrame.texts[0].alignToBaseline = false;
theFrame.texts[0].pointSize = 3;
theFrame.bringToFront();
theFrame.texts[0].contents = "";
theFrame.insertionPoints[0].select();
var erMes = mes6; // "Похоже, что в буфере нет текста. Или содержимое буфера текстом не является."
try {
    app.paste();
    }
catch (e) {
     theFrame.remove();
    alert(erMes + " [1]", programTitul);
    exit();      
    }
if (theFrame.texts[0].length == 0) {
    theFrame.remove();
    alert(erMes + " [2]", programTitul);
    exit();    
    }
///
var notUse = 0;
var newString = "";
// иногда, по непонятной причине, в содержимом буфера после копирования текста из некоторых pdf-файлов сначала идёт перевод строки и пробел, а потом уже тот текст, что был выделен.
for (var i = 0; i < theFrame.parentStory.texts[0].length; i++) { // i++
    if (theFrame.parentStory.texts[0].characters[i].contents == " ") {
        notUse = notUse+1; continue; 
        }
    if (theFrame.parentStory.texts[0].characters[i].contents == "\r") {
        notUse = notUse+1; continue; 
        }    
    if (theFrame.parentStory.texts[0].characters[i].contents == "\n") {
        notUse = notUse+1; continue; 
        }       
    break;
    } // i++
if (notUse > 0) {
    newString = theFrame.parentStory.texts[0].contents.substring(notUse, theFrame.parentStory.texts[0].length);
    theFrame.parentStory.texts[0].contents = newString;
    }
var typoQuotes = app.activeDocument.textPreferences.typographersQuotes;
app.activeDocument.textPreferences.typographersQuotes = false;
////
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\x{003F}"; 
app.changeGrepPreferences.changeTo = "\\?";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\"; 
app.changeGrepPreferences.changeTo = "\\\\"; // это не ошибка, так оформляется в скрипте поиск одиночной наклонной черты. В окне Найти/Заменить для поиска одной наклонной черты их будет стоять две. Объяснение: "экранирование экранирующего символа" -- корявая калька с английского.
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\)"; 
app.changeGrepPreferences.changeTo = "\\)";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\("; 
app.changeGrepPreferences.changeTo = "\\(";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\]"; 
app.changeGrepPreferences.changeTo = "\\]";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\["; 
app.changeGrepPreferences.changeTo = "\\[";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\r"; 
app.changeGrepPreferences.changeTo = "\\r*";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "\\x{00AD}"; 
app.changeGrepPreferences.changeTo = "\\x{00AD}*"; // для обработки переносов в тексте, взятом из PDF
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "(?<=[[:blank:]])[-–—]+(?=\\s)"; // плюс --- для учёта случая, что в вордовском файле тире оформлено как "пробел дефис дефис пробел". Предполагается, что в индизайне текст уже приведён в порядок, прежде чем будет использован этот скрипт
app.changeGrepPreferences.changeTo = "[-–—]";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "[[:blank:]]+"; 
app.changeGrepPreferences.changeTo = "\\h+";
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "[«»„“”\"\'‚‹›‘’]"; 
//app.changeGrepPreferences.changeTo = '\"';  // 05.07.2022  обнаружилось странное поведение при обработке текста этими запросами: если в одном запросе есть обработка кавычки и тире, то запрос не работает.
app.changeGrepPreferences.changeTo = "."; // поэтому для этой задачи поиска на месте любой кавычки будет точка -- по правилам grep это любой символ. Для такого поиска это упрощение вполне приемлемо.
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "([\\l\\d])([-‑])([\\l\\d])"; // вариант дефиса между буквами/цифрами -- обычный или неразрывный
app.changeGrepPreferences.changeTo = "$1[-‑]$3"; 
theFrame.parentStory.texts[0].changeGrep();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findChangeGrepOptions.includeFootnotes = true;
newString = theFrame.parentStory.texts[0].contents;
app.findGrepPreferences.findWhat = theFrame.parentStory.texts[0].contents;    
var found = space.findGrep();
theFrame.remove();
///
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
if (found.length == 0) {
    story.insertionPoints[startPosition].select();
    app.activeWindow.activePage = app.selection[0].parentTextFrames[0].parentPage; 
    app.activeWindow.zoomPercentage = usedZoom;    
    alert(mes7, programTitul); // "Текст не найден."
    app.activeDocument.textPreferences.typographersQuotes = typoQuotes;    
    app.documents[0].select(NothingEnum.nothing);
    exit();
    }
found[0].select();
app.activeWindow.activePage = app.selection[0].parentTextFrames[0].parentPage; 
app.activeWindow.zoomPercentage = 150;
app.activeDocument.textPreferences.typographersQuotes = typoQuotes;
exit();
///////
function getScriptPath() { //getScriptPath()
	try{
		return app.activeScript;
	}
	catch(e){
		return File(e.fileName);
	}
} //getScriptPath()